﻿using C1.TextParser;
using HtmlAgilityPack;
using Newtonsoft.Json.Linq;
using System.IO;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;

namespace ProductDetailFetcher
{
    public static class Extensions
    {
        public static bool IsValidXPath(this HtmlDocument doc, string xPath)
        {
            return doc.DocumentNode.SelectSingleNode(xPath) != null;
        }

        public static Stream ToStream(this string str)
        {
            return new MemoryStream(Encoding.ASCII.GetBytes(str));
        }

        public async static Task<string> ReadPageContentAsync(this HttpClient client, string uri)
        {
            var responseMessage = await client.GetAsync(uri);
            return await responseMessage.Content.ReadAsStringAsync();
        }

        public static T ToObject<T>(this IExtractionResult result)
        {
            var jObject = JObject.Parse(result.ToJsonString());
            var jToken = jObject.GetValue("Result");
            return jToken.ToObject<T>();
        }
    }
}
